﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Net.Sockets;
using System.IO;
using System.Net;

namespace WindowsFormsApplication2
{
    class ClientSocket
    {
        //초기화
        public Socket socket = null;    //server 연결을 위한 ClientSock
        public NetworkStream stream = null;    //socket의 stream 이동 통로
        public StreamWriter writer = null; //socket 에 msg 송신에 사용.
        public StreamReader reader = null; //socket 에 msg 수신에 사용.

        //소켓연결        
        public void conn(string IP, int PORT)
        {
            IPAddress serverIP = IPAddress.Parse(IP);
            int serverPort = PORT;

            //Socket 생성(생성 안되면, SocketException 발생!!!!!!)
            socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            //Socket 연결(연결 안되면, SocketException 발생!!!!!!)
            this.socket.Connect(new IPEndPoint(serverIP, serverPort));
            if (socket != null && socket.Connected)
            {
                //통신을 하기 위한 NetworkStream
                stream = new NetworkStream(socket);

                //메시지 전송 하기 위한 스트림 생성...
                writer = new StreamWriter(stream);

                //메시지를 읽어오기 위한 스트림 생성
                reader = new StreamReader(stream);
            }
            else
            {
                throw new Exception();
            }
        }

        //스트림에서 읽어오기(소켓 연결확인은 버튼을 누르면...! form 에서...)
        public string s_read()
        {
            try
            {
                string msg = reader.ReadLine();
                return msg;
            }
            catch (SocketException se)
            {
                MessageBox.Show(se.ToString());
                return "데이터를 읽을 수 없습니다.";
            }
       


        }

        //스트림에 쓰기
        public void s_write(string msg)
        {
            try
            {
                if (socket != null && socket.Connected) //연결상태 유무 확인
                {
                    writer.WriteLine(msg);
                    writer.Flush();
                }
                else
                    MessageBox.Show("먼저 채팅서버에 접속하세요!");
            }
            catch (SocketException se)
            {
                MessageBox.Show(se.Message.ToString());
            }
        }

        //소켓과 스트림 닫기
        public void s_close()
        {
            reader.Close();
            writer.Close();
            stream.Close();
            socket.Close();
         }
    }
}
