﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.IO;
using System.Threading;

namespace WindowsFormsApplication2
{
    public partial class Client : Form
    {
        public int i = 0;   //얘는걍... 이쁘게 할라고...초기화 문구 쪽에서 사용됨...니당...
        public Thread t1;   //recieve 돌리기 위한... Thread..

        ClientSocket cs = new ClientSocket();
        delegate void SetTextCallback(string msg);
        string chat_msg = "대화내용을 입력하세요.";

        //Form 초기화
        public Client()
        {
            InitializeComponent();
            this.send_Box.Text = chat_msg;
            this.addr_box.Text = "127.0.0.1";
            this.port_box.Text = "8080";
        }


        //연결(Socket 생성 & 연결, Stream변수 초기화, receive thread 생성)
        private void conn_Click(object sender, EventArgs e)
        {
            //IP랑 Port 확인.
            if (string.IsNullOrEmpty(this.addr_box.Text))
            {
                MessageBox.Show("IP주소를 입력하세요.");
                return;
            }
            string IP = this.addr_box.Text;

            if (string.IsNullOrEmpty(this.port_box.Text))
            {
                MessageBox.Show("PORT 번호를 입력하세요.");
                return;
            }
            int PORT = int.Parse(this.port_box.Text);

            //연결(Socket 생성 & 연결, Stream변수 초기화; stream, writer, reader)           
            try
            {
                //소켓을 열어주고, 소켓에 접속함(채팅 서버 접속 및 각 스트림 열어주기)
                cs.conn(IP, PORT);
                
                t1 = new Thread(receive);   
                t1.Start();
                if (cs.socket.Connected)
                {
                    this.chat_box.AppendText("서버에 접속 되었습니다. \r\n");
                }
            }

            //서버접속 실패나 이상이 생겼을 시에, chatting 창과 msg box로 에러메시지를 전송해준다.
            catch (SocketException se)
            {
                this.chat_box.AppendText("서버 접속을 실패하였습니다. (원인은.. MsgBox를 참고하세요..)" + Environment.NewLine);
                MessageBox.Show(se.Message.ToString());
            }

        }

        //퇴장 버튼
        private void exit_Click(object sender, EventArgs e)
        {
             try
              {
                  if (cs.socket != null && cs.socket.Connected) //소켓이 비어있지 않고, 소켓이 연결중이라면
                  {
                      cs.s_close(); //소켓과 스트림을 닫는 메서드
      
                      //쓰레드가 살이있으면 강제종료..
                      if (t1.IsAlive)
                          t1.Abort();

                      this.chat_box.AppendText("채팅서버에서 퇴장합니다. \r\n");
                  }
                  //그렇지 않으면
                  else
                      this.chat_box.AppendText("채팅서버에 연결되지 않았습니다. \r\n");
              }
              catch (SocketException se)
              {
                  MessageBox.Show(se.Message.ToString());
              }

        }
        
        //보내기 버튼
        private void send_Click(object sender, EventArgs e)
        {
            if (chat_msg == this.send_Box.Text 
                || string.IsNullOrEmpty(this.send_Box.Text))
            {
                this.send_Box.Clear();
                MessageBox.Show("대화내용을 입력해주세요.");
            }
            else
            {
                //스트림에 쓰는 메서드...
                cs.s_write("[client]" + this.send_Box.Text);

                this.send_Box.Clear();
            }
        }
      
        //크로스 쓰레드 문제를 해결하기 위한 방법.
        public void Add_MSG(string msg)
        {
            try
            {
                if (this.chat_box.InvokeRequired)
                {
                    SetTextCallback d = new SetTextCallback(Add_MSG);
                    this.Invoke(d, new object[] { msg });
                }
                else
                {
                    this.chat_box.AppendText(msg + "\r\n");
                    this.chat_box.ScrollToCaret();
                    this.chat_box.Focus();
                }
            }
            catch
            { }
        }

        //msg receive 
        private void receive()
        {
            try
            {
                //소켓이 비어있지 않고, 소켓이 연결중이면~ 무한루프(Thread 사용하기위해...)
                while (cs.socket != null && cs.socket.Connected)
                {
                    string readBuf = cs.s_read(); //스트림에서 읽어오기
                   if (readBuf == "[server]exit")
                    {
                        string err_msg = "서버에 이상이 있어 접속을 종료합니다.";
                        this.Add_MSG(err_msg);
                        
                        cs.s_close();
                        t1.Abort(); //Thread 강제종료
                    }
                    //byte[] readbuf = cs.s_read();
                    this.Add_MSG(readBuf);
                }
            }
            catch (SocketException se)
            {
                MessageBox.Show(se.Message.ToString());
            }
        }

        //대화입력창... 초기화 문구 지우기.
        private void send_Box_MouseClick(object sender, MouseEventArgs e)
        {
            if (i == 0)
            {
                this.send_Box.Clear();
                i++;
            }
        }

        //Font Dialog
        private void font_btn_Click(object sender, EventArgs e)
        {
            //폰트창 열기
            DialogResult dr = this.fontDialog1.ShowDialog();
            //확인 누르면 변경
            if (dr == DialogResult.OK)
            {
                chat_box.Font = fontDialog1.Font;
                send_Box.Font = fontDialog1.Font;
            }
        }

        //Coloer Dialog
        private void color_btn_Click(object sender, EventArgs e)
        {
            //색상창 열기 후, 색 지정
            if (colorDialog1.ShowDialog() != DialogResult.Cancel)
            {
                chat_box.ForeColor = colorDialog1.Color;
                send_Box.ForeColor = colorDialog1.Color;
            }
        }
    }
}
